Am2Al <- function (mat) 
{
#
# converts an adjacency or incidence matrix to an adjacency list format
# (see adjListBGL.R for more information)
#
    if (!is.matrix(mat)) 
        stop("needs mat")
    if (nrow(mat) != ncol(mat)) 
        stop("needs square mat")
    rs <- 1:nrow(mat)
    cs <- 1:ncol(mat)
    if (!all(sort(unique(as.double(mat))) == c(0, 1))) 
        stop("needs incidence mat")
    prs <- NULL
    f <- function(x, y) if (length(x) > 0) 
        rbind(x, y)
    else NULL
    for (i in cs) prs <- cbind(prs, f(rs[mat[, i] == 1], i))
    prs-1 # to get zero-base
}
